/*
text2domNode function is from PiyoTrackbackPing.
Special Thanks to kuki<kuki@piyosystems.com>
Reference: http://www.piyosystems.com/kuki/B1356262698/C1616335468/E201637195/index.html
*/

XmlParser = Class.create();
XmlParser.prototype ={
 	DEFAULT_CHARSET : "UTF-8" , 
	 xmlReq : Object, 
	initialize : function(){
	
	},
	text2domNode : function(text) {
		  var fileCharSet = this.getXMLEncoding(text);
		  this.writeFile(text, "xml_text", fileCharSet);
 		  return this.readXMLFile("xml_text");
	},

	writeFile : function (text, filename, fileCharSet) {

		  var cmd = "/bin/echo \"" + this.escapeQuote(text) + "\" | " +
                      "/usr/bin/iconv -c -f UTF-8-MAC -t UTF-8 |" +
                      "/usr/bin/iconv -c -f UTF-8 -t " + fileCharSet +  " > " + filename;

		  var status = widget.system(cmd, null).status;
		  if (status == 0) {
   				// debug("writeFile succeeded");
		  } else {
			   // error("writeFile failed: " + filename);
		  }
	} , 

	readFile : function(filename) {
  			var cmd = "/bin/cat " + filename;
  			var result = widget.system(cmd, null).outputString;
  			if (result == null) {
    			//error("readFile failed: " + filename);
			  }
 			 return null;
	},

	readXMLFile :function (filename) {
		  var lReq = new XMLHttpRequest();
		  var url = "./" + filename;

		  lReq.open("GET", url, false);
		  lReq.setRequestHeader("Cache-Control", "no-cache");
		  lReq.send(null);

		  if((lReq.status == 200) || (lReq.status == undefined)) {
				//alert(lReq.responseText);
				
			//	this.xmlReq = lReq;
			//this.xmlObj = lReq.responseXML;
			return lReq.responseXML;
		  } else {
		    return null;
		  }
	},

	getXMLEncoding : function(text) {
		  if (text != undefined) {
			    text.match(/<\?\s*xml\s+.*encoding\s*=\s*['\"]([^'\"]+)['\"]\s*\?>/);
			    try {
      				var result = RegExp.$1;
      				return result;
		    	} catch (e) {
				      return this.DEFAULT_CHARSET;
			    }
		  } else {
    			return this.DEFAULT_CHARSET;
		  }
	},

	escapeQuote : function(target) {
		  var result = target.replace(/\"/g, "\\\"");
		  return result;
	}
}