// required prototype.js

var gRssItems = new Array();
var gSelRssIdx = 0;  // for front panel
var gSelEntryIdx =0;  // for back panel
var gWidgetHideTime;
var CONST_RELOAD_SECOND = 120 ;

var gFlipShowMasterSw = false;
var gFlgScrollEnable = false;

var gListArray =new Array();
ListItem = Class.create();
ListItem.prototype ={
	url:"" , title:"" , 
	initialize : function(url , title ){
		this.url = url;
		this.title = title;
	}
}

function init(){

	$('rssUrlLabel').innerText = getLocalizedString("rssUrlLabel");
	$('rssTitleLabel').innerText = getLocalizedString("rssTitleLabel");
  createGenericButton($('readRssButton'), getLocalizedString("readRssButton"));
  createGenericButton($('addButton'), getLocalizedString("addButton") );
  createGenericButton($('modifyButton'),  getLocalizedString("modifyButton"));
  createGenericButton($('delButton'), getLocalizedString("delButton"));
  createGenericButton($('doneButton'), getLocalizedString("doneButton"));



	// attach widge event
	if(window.widget){
		widget.onshow= widgetOnShow;
		widget.onhide = widgetOnHide;
	}

	// restore status
  if (window.widget) {
	  var listLength = widget.preferenceForKey("urlListLength");
	  for(var i=0; i < listLength ; i++) {
	        var tmpUrl  = widget.preferenceForKey("listUrl" + i);
	        var tmpTitle  = widget.preferenceForKey("listTitle" + i);
			var listItem = new ListItem(tmpUrl , tmpTitle);
			gListArray.push(listItem);
	}
	
	 var tmpSelectRssIdx  = widget.preferenceForKey("selectRssIdx");
	 if (listLength >= tmpSelectRssIdx){
	 	gSelRssIdx = tmpSelectRssIdx;
	 }
  }

	// preset initial entry 
  if(gListArray.length == 0 ){
	 var item1 =new ListItem("http://pookmark.jp/popular/rss","POOKMARK Airlines - 最近人気の行き先");
	 var item2 =new ListItem("http://b.hatena.ne.jp/hotentry?mode=rss","はてなブックマーク 最近の人気エントリー");
	 var item3 =new ListItem("http://b.hatena.ne.jp/entrylist?mode=rss&sort=hot","はてなブックマーク - 注目エントリー一覧");
  	var item4 = new ListItem("http://del.icio.us/rss/popular/","del.icio.us/popular");
  	var item5 = new ListItem("http://del.icio.us/rss/","del.icio.us recent entry");
	
	gListArray.push(item1);	
	gListArray.push(item2);
	gListArray.push(item3);  
	gListArray.push(item4);  
	gListArray.push(item5);  
  }

	updateRssList();
	updateEntryList();
	
	var rssListBox = $('rssListBox');
	rssListBox.selectedIndex = 	gSelRssIdx;

	selectRssList();
}

function loadItems(url){

		gFlipShowMasterSw =false;
		var ajaxObj = new Ajax.Request(url ,
			{method: 'get', parameters: "", asynchronous: true,onComplete: itemsOnComplete.bind(this),onLoading:itemsOnLoading});

}

itemsOnLoading = function(){
	$('stat').innerHTML = getLocalizedString("nowLoadingMes");
}

itemsOnComplete =function(resObj){

	if (resObj.status==200){

			var xmlObj = resObj.responseXML;
			if (xmlObj == null || xmlObj == undefined){

				var XmlParser = new this.XmlParser();
				xmlObj = XmlParser.text2domNode(resObj.responseText);

				//xmlObj =XmlParser.xmlReq.responseXML;

				if (xmlObj == null || xmlObj == undefined) {
					$('stat').innerHTML = getLocalizedString("readRssError");
					gFlipShowMasterSw =true;
					return;
				}
			}
				$('stat').innerHTML = getLocalizedString("readCompleteMes");
				var rssContents= new this.rssContents(xmlObj);
				//alert(rssContents.getHeader().title);
				gRssItems = rssContents.getItems();

				var tmpClass ;
				var listHtml;
				listHtml ="<ul>";
				for (var i = 0 ; i < gRssItems.length ; i++){
					tmpClass = ( (i % 2 ==0 ) ? "listBack1" : "listBack2");
					
					listHtml += "<li><a href=\"javascript:urlLink(\'" + gRssItems[i].link + "\');\" class=\"" + tmpClass +  "\">" + gRssItems[i].title + "</a></li>";
				}
				listHtml += "</ul>";

				$('myRssList').innerHTML  =listHtml;

					calculateAndShowThumb($('myRssList'));
	}else{
				$('stat').innerHTML = getLocalizedString("rssNotFoundError");
	}
	gFlipShowMasterSw =true;
}


function loadHeader(url){
		var ajaxObj = new Ajax.Request(url , 
			{method: 'get', parameters: "", asynchronous: true,onComplete:headerOnComplete ,onLoading:headerOnLoading});

}
headerOnLoading = function(){
	setMessage(getLocalizedString("titleLoadingMes"));

}

headerOnComplete =function(resObj){

		var xmlObj = resObj.responseXML;

		if (resObj.status == 200){

			if (xmlObj ==null ){

				var XmlParser = new this.XmlParser();
				xmlObj = XmlParser.text2domNode(resObj.responseText);

				if (xmlObj == null ) {
					setMessage(getLocalizedString("readRssError"));
					return;
				}
			}

			var rssContents= new this.rssContents(xmlObj);
			$('rssTitle') .value = rssContents.getHeader().title;
			setMessage(getLocalizedString("titleLoadCompleteMes"));
		}else{
			setMessage(getLocalizedString("readFailMes"));
		}
}

/* ウィジェットの動作経過時間によるリロード処理 */

function widgetOnShow(){

	if (gWidgetHideTime != undefined){
		var now = new Date();
		var diffTime = parseInt((now.getTime() - gWidgetHideTime.getTime()) / 1000); 
		if ( diffTime > CONST_RELOAD_SECOND ){
			urlRefresh();
		}
	}

}

function widgetOnHide(){
	gWidgetHideTime =new Date(); 
}


/* front UI */

function selectRssList(){

		var rssListBox = $('rssListBox');
		gSelRssIdx = rssListBox.selectedIndex;
		entryTitle =  gListArray[gSelRssIdx].title;

		entryTitle = cutString(entryTitle , 34);
		$('rssListText').innerHTML = entryTitle;
		if (window.widget){
			widget.setPreferenceForKey(gSelRssIdx, "selectRssIdx");
		}
		loadItems(gListArray[gSelRssIdx].url);

}

function updateRssList(){
	var listBox = $('rssListBox');
	var selecter="";
	for (var i = 0 ; i < gListArray.length ; i++){
			var entryTitle = this.gListArray[i].title;
			entryTitle = cutString(entryTitle , 44);
			if (i == gSelRssIdx)
				selecter += "<option value=" + i + " selected>" + entryTitle + "</option>\n";
			else
				selecter += "<option value=" + i + ">" + entryTitle + "</option>\n";
	}
	listBox.innerHTML= selecter;
}


function urlLink(url){

	if (window.widget){
		setTimeout (widget.openURL(url),10);
	}else{
		location.href =url ;
	}

}

function urlRefresh(){
	loadItems(gListArray[gSelRssIdx].url);

}


function refreshBtnDown(event)
{
	event.target.src = "Images/refresh_down.png";
	event.stopPropagation();
	event.preventDefault();
}

function refreshBtnUp (event)
{
	event.target.src = "Images/refresh.png";
	urlRefresh();
	
	event.stopPropagation();
	event.preventDefault();
}
function refreshBtnOut (event)
{
	event.target.src = "Images/refresh.png";
}


function goPrefs(event){
	if (gFlipShowMasterSw ==false) return;

	setMessage("");
	showPrefs(event);
	gFlgScrollEnable = false;


}

/* back UI */

function selectList(){
		var listBox = $('urlListBox');
		gSelEntryIdx = listBox.selectedIndex;

		$('rssUrl').value = gListArray[gSelEntryIdx].url;
		$('rssTitle').value = gListArray[gSelEntryIdx].title;
		setMessage("");

}

function addEntry(){
	var url = $('rssUrl').value;
	var title =$('rssTitle').value;
	
	for (var i=0 ; i < gListArray.length ; i++){
		if (url == gListArray[i].url){
			setMessage(getLocalizedString("existURLError"));
			return;
		}
	}

	if (url == ""){
			setMessage(getLocalizedString("inputURLMes"));
	}else if (title ==""){
			setMessage(getLocalizedString("inputTitleMes"));
	}else{
			if (!isURL(url)){
				setMessage(getLocalizedString("notURLError"));
				return;
			}

	var listItem = new ListItem(url , title);
		gListArray.push (listItem);
		updateEntryList();
		$('rssUrl').value ="";
		$('rssTitle').value ="";
		setMessage(getLocalizedString("addFinishMes"));
		}
}

function modifyEntry(){
	var url = $('rssUrl').value;
	var title =$('rssTitle').value;
	var listBox = $('urlListBox');

	if (url == ""){
			setMessage(getLocalizedString("inputURLMes"));
	}else if (title ==""){
			setMessage(getLocalizedString("inputTitleMes"));
	}else{
			if (!isURL(url)){
				setMessage(getLocalizedString("notURLError"));
				return;
			}
	
		if (gSelEntryIdx == listBox.selectedIndex){
			gListArray[gSelEntryIdx].url = url;
			gListArray[gSelEntryIdx].title = title;
			updateEntryList();
			$('rssUrl').value ="";
			$('rssTitle').value ="";
			setMessage(getLocalizedString("modifyFinishMes"));
		}else{
			setMessage(getLocalizedString("modifyError"));
		}
	}
}

function readRss(){
	var url = $('rssUrl').value;

	if (!isURL(url)){
		setMessage(getLocalizedString("notURLError"));
		return;
	}
	
	if (url == ""){
			setMessage(getLocalizedString("inputURLMes"));
	}else{
		setMessage("");
		loadHeader(url);
	}
}

function delEntry(){
	var listBox = $('urlListBox');
	if (listBox.selectedIndex != -1){
		gListArray.splice(listBox.selectedIndex ,1);
		updateEntryList();
		$('rssUrl').value ="";
		$('rssTitle').value ="";
		setMessage(getLocalizedString("delFinishMes"));
	}else{
		setMessage(getLocalizedString("notSelectedError"));
	}
}

function setMessage(mes){
	$('entryMessage').innerHTML= mes;
}

function updateEntryList(){
	var listBox = $('urlListBox');
	var selecter="";
	for (var i = 0 ; i < gListArray.length ; i++){
			var entryTitle = this.gListArray[i].title;
			selecter += "<option value=" + i + ">" + entryTitle + "</option>\n";
	}
	listBox.innerHTML= selecter;
}

function donePrefs(){

  if (window.widget) {
	  var oldListLength = widget.preferenceForKey("urlListLength");
	  for(var i=0; i < oldListLength ; i++) {
			widget.setPreferenceForKey(null, "listUrl" + i);
			widget.setPreferenceForKey(null, "listTitle" + i);
	}
	  var listLength = gListArray.length;
		widget.setPreferenceForKey(listLength, "urlListLength");
  
		for(var i=0; i < listLength ; i++) {
				widget.setPreferenceForKey(gListArray[i].url, "listUrl" + i);
				widget.setPreferenceForKey(gListArray[i].title, "listTitle" + i);
		}
  }
	updateRssList();
	
	var listBox = $('urlListBox');
	listBox.selectedIndex =-1;
	$('rssUrl').value ="";
	$('rssTitle').value ="";
	setMessage("");
	hidePrefs();
	gFlgScrollEnable = true
}

/*util  */

function getLocalizedString(key) {
//	try {
		var retString = localizedStrings[key];
		if (retString === undefined) {
		retString = key;
		}
		return retString;
//	} catch(err) {
//		return "##";
//	}
	return key;
}


function cutURL(url){

	return url.match(/(http:|https:)\/\/[^\/]*.[^\/]*\//);

}

function isURL(urlString){

	var urlMatch =  urlString.match(/(http:|https:)\/\//);
	if (urlMatch && urlMatch.length) urlMatch= urlMatch[0];

	if (urlMatch == "http://" || urlMatch == "https://")
			return true;
		else
			return false;

}

function strByte(str){

	if (!str) return 0;
	
	var lenHan = lenHankaku(str);
	return  str.length * 2 - lenHan;

}

function lenHankaku(str){

	var ret = str.match(/[!-~]*/g);
	var len=0;
	for (var i=0 ; i<ret.length ; i++){
		if (ret[i].length >0 ){
			len +=  ret[i].length;
		}
	}
	return len;
}
function isHankaku(str){
	return (str == str.match(/[!-~]*/g));
}

function cutString(str , bt){
	if (!str) return "";

	if (strByte(str) > bt){

		var retStr="";
		var tmpByte=0;
		var thisByte;
		for (i=0 ; i < str.length ; i++){
			thisByte = isHankaku( str.substring(i , i+1)) ? 1 : 2;
			if ((tmpByte + thisByte) > bt){
				return retStr + "...";
			}else{
				tmpByte += thisByte;
				retStr += str.substring(i , i+1 );
			}
		}
		return str;	
	}else{
		return str;
	}
}

